import java.util.Arrays;

/*
Schreiben bzw. vervollständigen Sie gekennzeichnete Programmteile wie in den Kommentaren beschrieben.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile!
Verwenden Sie die gegebenen Testklassen zum Überprüfen Ihrer Lösung. Die Korrektheit dieser Testfälle
ist notwendig, aber nicht hinreichend für eine korrekte Lösung. Es werden damit nur bestimmte
Spezialfälle geprüft. Liefern die Testklassen keinen Fehler, garantiert dies noch nicht die
Korrektheit Ihrer Lösung gemäß der Angabe.
*/
public class Aufgabe1 {

    /*
    Aufgabe: Manipulation von einfachen Arrays.

        Ergänzen Sie fehlende Teile dieser Klasse entsprechend den Kommentaren
        an den mit TODO gekennzeichneten Stellen.
        Sonstige Anforderungen: Die Verwendung der Klasse 'String' oder 'StringBuffer'
        ist nicht erlaubt. Es sollen keine zusätzlichen Methoden implementiert werden.
        Hinweis: Die beiden gefragten Methoden funktionieren ähnlich. Sie dürfen sich
        daher gegenseitig aufrufen, oder auch unabhängig implementiert werden.

    Punkte (maximal 20):
        10 Punkte für die Implementierung von 'largestRemainder',
        10 Punkte für die Implementierung von 'addLargestRemainder'.
    */

    // Berechnet für alle Einträge von 'array' im Indexbereich inklusive
    // 'pos' bis array.length-1 den Rest der Division durch 'divisor' und
    // schreibt das Maximum der Ergebnisse an die Position 'pos'.
    // Alle Einträge ab inklusive 'pos' verschieben sich um eine Position Richtung
    // größerem Index, um für den neuen Eintrag Platz zu machen.
    // Der ursprünglich letzte Eintrag an der Position array.length-1 geht
    // durch die Verschiebung verloren.
    // Beachten Sie die Beispiele in der Methode 'main' (siehe unten).
    // Vorbedingung: array != null und array.length > 0 und pos ist ein gültiger Index,
    // divisor > 0.
    public static void largestRemainder(int[] array, int divisor, int pos) {
        // TODO: implementieren Sie die Methode.

        if(array==null||array.length<=0||pos>=array.length||divisor<=0||pos<0){
            return;
        }
        int largestRem = 0;

        for (int i = pos; i<array.length;i++){
            if((array[i]%divisor) > largestRem){
                largestRem = array[i]%divisor;
            }
        }

        int hilfs = 0, hilfsAlt=0;
        hilfsAlt=largestRem;


        for (int i = pos; i<array.length;i++){
            hilfs=array[i];
            array[i]=hilfsAlt;
            hilfsAlt=hilfs;
        }

    }

    // Berechnet für alle Einträge von 'array' den Rest der Division durch 'divisor'.
    // Liefert ein neues Array der Länge array.length+1 zurück an dessen Position 0
    // der maximale Rest steht.
    // An den Positionen 1 bis array.length stehen alle Einträge aus array.
    // Vorbedingung: array != null und array.length > 0,
    // divisor > 0.
    public static int[] addLargestRemainder(int[] array, int divisor) {
        // TODO: implementieren Sie die Methode.

        if(array==null||array.length<=0||divisor<=0){
            return null;        //da in der Aufgabenstellung nicht definiert wurde, was zurückgegeben soll wenn VB nicht erfüllt; gilt auch für alle folgenden Vorbedingungen in diesem Test
        }

        int[] ar = array.clone();

        largestRemainder(ar,divisor,0);

        int[] ar2 = new int[array.length+1];

        for (int i = 0; i<array.length;i++){
            ar2[i]=ar[i];
        }

        ar2[ar2.length-1]= array[array.length-1];



        return ar2; //TODO: Diese Zeile löschen oder entsprechend verändern.
    }

    // Diese Methode können Sie zum Testen nutzen. Sie geht nicht in die Beurteilung ein.
    public static void main(String[] args) {

        //Testen von largestRemainder:
        int[] array = new int[]{15,12,10,14,17};
        largestRemainder(array,5,0);
        System.out.println(Arrays.toString(array)); //[4, 15, 12, 10, 14]

        array = new int[]{15,12,10,14,17};
        largestRemainder(array,5,3);
        System.out.println(Arrays.toString(array)); //[15, 12, 10, 4, 14]

        array = new int[]{15,12,10,14,17};
        largestRemainder(array,5,2);
        System.out.println(Arrays.toString(array)); //[15, 12, 4, 10, 14]

        //Testen von addLargestRemainder:
        array = new int[]{15,12,10,14,17};
        System.out.println(Arrays.toString(addLargestRemainder(array,5))); //[4, 15, 12, 10, 14, 17]

        array = new int[]{15};
        System.out.println(Arrays.toString(addLargestRemainder(array,5))); //[0] //wohl ein Fehler?! Rest soll doch vorne angefügt werden ?

    }
}

